"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
/**
 *
 */
function array(_a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable, min = _b.min, max = _b.max, unique = _b.unique;
    required = required !== undefined ? required : true;
    nullable = nullable !== undefined ? nullable : false;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        //
        var wrap = utils_1.wrapSchema(target);
        if (wrap.properties !== undefined && name in wrap.properties === false) {
            throw new TypeError('@array() must be used with other @props method');
        }
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    __assign(__assign(__assign({ type: 'array', items: wrap.properties[name] }, (min !== undefined && { minItems: min })), (max !== undefined && { maxItems: max })), (unique !== undefined && { uniqueItems: unique })),
                    { type: 'null' },
                ],
            };
        }
        else {
            wrap.properties[name] = __assign(__assign(__assign({ type: 'array', items: wrap.properties[name] }, (min !== undefined && { minItems: min })), (max !== undefined && { maxItems: max })), (unique !== undefined && { uniqueItems: unique }));
        }
    };
}
exports.default = array;
//# sourceMappingURL=array.js.map