"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.anyOf = exports.allOf = exports.oneOf = void 0;
var utils_1 = require("../utils");
function oneOf(targets, _a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable;
    required = required !== undefined ? required : true;
    nullable = nullable !== undefined ? nullable : false;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        var wraps = targets.map(utils_1.wrapSchema);
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    {
                        oneOf: wraps,
                    },
                    { type: 'null' },
                ],
            };
        }
        else {
            wrap.properties[name] = {
                oneOf: wraps,
            };
        }
        if (required) {
            var r = wrap.required;
            r.push(name);
        }
    };
}
exports.oneOf = oneOf;
function allOf(targets, _a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable;
    required = required !== undefined ? required : true;
    nullable = nullable !== undefined ? nullable : false;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        var wraps = targets.map(utils_1.wrapSchema);
        if (nullable) {
            wrap.properties[name] = {
                anyOf: [
                    {
                        allOf: wraps,
                    },
                    { type: 'null' },
                ],
            };
        }
        else {
            wrap.properties[name] = {
                allOf: wraps,
            };
        }
        if (required) {
            var r = wrap.required;
            r.push(name);
        }
    };
}
exports.allOf = allOf;
function anyOf(targets, _a) {
    var _b = _a === void 0 ? {
        required: true,
        nullable: false,
    } : _a, required = _b.required, nullable = _b.nullable;
    required = required !== undefined ? required : true;
    nullable = nullable !== undefined ? nullable : false;
    return function (target, name
    // descriptor: PropertyDescriptor
    ) {
        var wrap = utils_1.wrapSchema(target);
        var wraps = targets.map(utils_1.wrapSchema);
        if (nullable) {
            wrap.properties[name] = {
                anyOf: __spreadArray(__spreadArray([], __read(wraps)), [{ type: 'null' }]),
            };
        }
        else {
            wrap.properties[name] = {
                anyOf: wraps,
            };
        }
        if (required) {
            var r = wrap.required;
            r.push(name);
        }
    };
}
exports.anyOf = anyOf;
//# sourceMappingURL=of.js.map