import { JsonSchema4Boolean, JsonSchema4Null, JsonSchema4Numeric, JsonSchema4String } from '../jsonschema4';
export declare type AnyProp = {
    [key: string]: any;
};
export declare type SchemaProp = {
    required: boolean;
    nullable: boolean;
    schema?: (JsonSchema4String & AnyProp) | (JsonSchema4Numeric & AnyProp) | (JsonSchema4Boolean & AnyProp) | JsonSchema4Null;
};
export declare type ValidConstructor = StringConstructor | NumberConstructor | BooleanConstructor | DateConstructor;
declare function prop(): ReturnType<typeof prop>;
declare function prop(type: StringConstructor, prop?: {
    required?: boolean;
    nullable?: boolean;
    schema?: JsonSchema4String & AnyProp;
}): any;
declare function prop(type: NumberConstructor, prop?: {
    required?: boolean;
    nullable?: boolean;
    schema?: JsonSchema4Numeric & AnyProp;
}): any;
declare function prop(type: BooleanConstructor, prop?: {
    required?: boolean;
    nullable?: boolean;
    schema?: JsonSchema4Boolean & AnyProp;
}): any;
declare function prop(type: DateConstructor, prop?: {
    required?: boolean;
    nullable?: boolean;
    schema?: AnyProp;
}): any;
export default prop;
//# sourceMappingURL=prop.d.ts.map