import { JSONSchema4 } from 'json-schema';
import { SchemaProp } from './decorators/prop';
export interface Ctos {
    new (...args: any[]): any;
}
export interface CtosSchema extends Ctos {
    __schema: JSONSchema4;
    __proto__?: CtosSchema;
}
export interface Meta {
    name: 'Number' | 'String' | 'Boolean' | 'Date' | 'Object' | 'Array';
}
/**
 *
 */
export declare function wrapSchema(target: Ctos): CtosSchema['__schema'];
export declare function getMetadata(target: Ctos, name: string): Meta;
export declare function isProperty(type: string): boolean;
/**
 *
 */
export declare function buildProperty(type: Meta['name'], props?: SchemaProp['schema']): {
    type: import("json-schema").JSONSchema4TypeName | import("json-schema").JSONSchema4TypeName[] | undefined;
} | {
    type: "null";
    description?: string | undefined;
} | {
    type: "string";
    minLength?: number | undefined;
    maxLength?: number | undefined;
    pattern?: string | undefined;
    format?: import("./jsonschema4/string").JsonSchema4StringFormat | undefined;
    enum?: string[] | undefined;
    default?: string | undefined;
    description?: string | undefined;
} | {
    type: "number" | "integer";
    multipleOf?: number | undefined;
    minimum?: number | undefined;
    exclusiveMinimum?: number | undefined;
    maximum?: number | undefined;
    exclusiveMaximum?: number | undefined;
    default?: number | undefined;
    description?: string | undefined;
    enum?: number[] | undefined;
} | {
    type: "boolean";
    default: boolean;
    description?: string | undefined;
};
export declare function composeProperty(type: JSONSchema4['type'], props?: SchemaProp['schema']): {
    type: import("json-schema").JSONSchema4TypeName | import("json-schema").JSONSchema4TypeName[] | undefined;
} | {
    type: "null";
    description?: string | undefined;
} | {
    type: "string";
    minLength?: number | undefined;
    maxLength?: number | undefined;
    pattern?: string | undefined;
    format?: import("./jsonschema4/string").JsonSchema4StringFormat | undefined;
    enum?: string[] | undefined;
    default?: string | undefined;
    description?: string | undefined;
} | {
    type: "number" | "integer";
    multipleOf?: number | undefined;
    minimum?: number | undefined;
    exclusiveMinimum?: number | undefined;
    maximum?: number | undefined;
    exclusiveMaximum?: number | undefined;
    default?: number | undefined;
    description?: string | undefined;
    enum?: number[] | undefined;
} | {
    type: "boolean";
    default: boolean;
    description?: string | undefined;
};
//# sourceMappingURL=utils.d.ts.map