"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.composeProperty = exports.buildProperty = exports.isProperty = exports.getMetadata = exports.wrapSchema = void 0;
/**
 *
 */
function wrapSchema(target) {
    var classSchema = '__schema' in target
        ? target
        : target.constructor;
    // console.log('target', target)
    // console.log('classSchema', classSchema.__schema)
    // console.log('constructor', target.constructor)
    // console.log('parent', target.constructor.__proto__.constructor)
    var extend = target.constructor.prototype.__proto__.constructor !== Object;
    if (extend &&
        (classSchema.__schema === undefined || 'type' in classSchema.__schema)) {
        classSchema.__schema = {
            properties: {},
            required: [],
        };
    }
    if (extend === false && '__schema' in classSchema === false) {
        classSchema.__schema = {
            properties: {},
            required: [],
        };
    }
    return classSchema.__schema;
}
exports.wrapSchema = wrapSchema;
function getMetadata(target, name) {
    try {
        return Reflect.getMetadata('design:type', target, name);
    }
    catch (error) {
        throw new TypeError("unable to retrive metadata for " + target.constructor.name + "::" + name + ". " + error);
    }
}
exports.getMetadata = getMetadata;
function isProperty(type) {
    return ['Number', 'String', 'Boolean', 'Date'].includes(type);
}
exports.isProperty = isProperty;
/**
 *
 */
function buildProperty(type, props) {
    switch (type) {
        case 'Number':
            return composeProperty('number', props);
        case 'String':
            return composeProperty('string', props);
        case 'Boolean':
            return composeProperty('boolean', props);
        case 'Date':
            return composeProperty('string', __assign(__assign({}, props), { format: 'date-time', datetime: 'ISO8601' }));
        default:
            return composeProperty('object', props);
    }
}
exports.buildProperty = buildProperty;
function composeProperty(type, props) {
    return __assign({ type: type }, props);
}
exports.composeProperty = composeProperty;
//# sourceMappingURL=utils.js.map